Subject: Re: [PATCH net-next] packet: respect devices with LLTX flag in direct xmit

From: Daniel Borkmann <[email-masked]>
Date: Sun, 30 Mar 2014 23:52:04 +0200

On 03/29/2014 04:02 PM, Eric Dumazet wrote:
> On Fri, 2014-03-28 at 22:13 +0100, Daniel Borkmann wrote:
>> On 03/28/2014 09:50 PM, David Miller wrote:
>
>>> The only remaining issue is that Eric seems to suggest that a tx
>>> dropped counter bump should be added.  Please submit that as a
>>> follow-on if my reading of his feedback is accurate.
>>
>> Yes, will do next week. I think at time of submission we didn't
>> have that yet. :)
>
> BTW, how direct xmit performs in case of BQL enabled driver ?
>
> dummy is nice, but not really representative of real device ;)
>
> netif_xmit_frozen_or_stopped() tests (dev_queue->state &
> QUEUE_STATE_ANY_XOFF_OR_FROZEN), so will not fill TX ring.
>
> Since you have no queue, I would rather use a test without
> BQL bit (1 << __QUEUE_STATE_STACK_XOFF), so that you can absorb bursts
> into TX ring ...

Thanks Eric, I'll look into it on next Tuesday [I was on travel
whole weekend and will be on Monday].